﻿using System;
using System.Data;
using System.Windows.Forms;
using System.Linq;
using Infragistics.Win.UltraWinGrid;
using System.Collections.Generic;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        List<UltraGridColumn> nonFixedColumns = new List<UltraGridColumn>();

        public Form1()
        {
            InitializeComponent();
            var dt = new DataTable();
            dt.Columns.AddRange(new []
            {
                new DataColumn("id", typeof(int)), 
                new DataColumn("col1", typeof(string)), 
                new DataColumn("col2", typeof(int)), 
                new DataColumn("col3", typeof(string)), 
                new DataColumn("col4", typeof(int))
            });
            dt.Rows.Add(1, "11", 12, "13", 14);
            dt.Rows.Add(2, "21", 22, "23", 24);
            dt.Rows.Add(3, "31", 32, "33", 34);
            ultraGrid1.SetDataBinding(dt, "", true, true);
            
            ultraGrid2.DataSource = ultraGrid1.DataSource;
            
            
            
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            ultraGrid1.DisplayLayout.Bands[0].RowLayoutStyle = checkBox1.Checked
                ? RowLayoutStyle.GroupLayout
                : RowLayoutStyle.None;
            ultraGrid2.DisplayLayout.Bands[0].RowLayoutStyle = checkBox1.Checked
                ? RowLayoutStyle.GroupLayout
                : RowLayoutStyle.None;
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            var fixedColumns = e.Layout.Bands[0].Columns.OfType<UltraGridColumn>().
                Where(c => c.Header.Fixed).ToList();

            nonFixedColumns = e.Layout.Bands[0].Columns.OfType<UltraGridColumn>().
               Except(fixedColumns).ToList();

            foreach (var column in fixedColumns)
            {
                column.Hidden = true;
            }
        }

        private void ultraGrid2_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.CopyFrom(ultraGrid1.DisplayLayout);

            foreach (var column in e.Layout.Bands [0].Columns)
            {
                column.Hidden = !column.Header.Fixed;
            }

            e.Layout.AutoFitStyle = AutoFitStyle.ResizeAllColumns;
        }
    }
}
